//
//  main.c
//  testsdlgl
//
//  Created by Daniel Bokser on 9/26/18.
//  Copyright © 2018 dan. All rights reserved.
//
#include <stdio.h>
#include <SDL2/SDL.h>
#include <OpenGL/gl.h>
#include <pthread.h>
#include <stdbool.h>

typedef struct ThreadContext {
    SDL_Window *window;
    SDL_GLContext context;
    SDL_Renderer *renderer;
    
} ThreadContext;
static bool isRunning = true;

void renderSecondScreen(const ThreadContext *tc) {
    SDL_GL_MakeCurrent(tc->window, tc->context);
    glClearColor(0, 1.0, 1.0, 1.0);
    glClear(GL_COLOR_BUFFER_BIT);
    
    SDL_GL_SwapWindow(tc->window);
    SDL_GL_MakeCurrent(tc->window, NULL);
    
}
void *secondRender(void *arg) {
    ThreadContext *tc = (ThreadContext*)arg;
   
    while (isRunning) {
        renderSecondScreen(tc);
    }
    return NULL;
}
int initSDLWindow(pthread_t *secondThread, ThreadContext *tc) {
    tc->window =   SDL_CreateWindow("Test SDL 2nd Renderer", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, 300, 300, SDL_WINDOW_SHOWN);
    tc->renderer = SDL_CreateRenderer(tc->window, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC);
    
    return 0;
}
int initGLWindow(pthread_t *secondThread, ThreadContext *tc) {
    SDL_GL_SetAttribute(SDL_GL_CONTEXT_FLAGS, SDL_GL_CONTEXT_FORWARD_COMPATIBLE_FLAG);
    SDL_GL_SetAttribute(SDL_GL_CONTEXT_PROFILE_MASK, SDL_GL_CONTEXT_PROFILE_CORE);
    SDL_GL_SetAttribute(SDL_GL_DOUBLEBUFFER, 1);
    SDL_GL_SetAttribute(SDL_GL_DEPTH_SIZE, 24);
    SDL_GL_SetAttribute(SDL_GL_STENCIL_SIZE, 8);
    SDL_GL_SetAttribute(SDL_GL_CONTEXT_MAJOR_VERSION, 3);
    SDL_GL_SetAttribute(SDL_GL_CONTEXT_MINOR_VERSION, 3);
    SDL_GL_SetSwapInterval(1);
    tc->window = SDL_CreateWindow("Test OpenGL", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, 300, 300, SDL_WINDOW_SHOWN | SDL_WINDOW_OPENGL);
    tc->context = SDL_GL_CreateContext(tc->window);
    SDL_GL_MakeCurrent(tc->window, tc->context);
    
   
    pthread_create(secondThread, NULL, secondRender, tc);
    
    return 0;
}
int main(int argc, const char * argv[]) {
    SDL_Init(SDL_INIT_EVERYTHING);
   
    pthread_t secondThread;
   
    SDL_Window *window = SDL_CreateWindow("Test SDL Renderer", SDL_WINDOWPOS_UNDEFINED, SDL_WINDOWPOS_UNDEFINED, 300, 300, SDL_WINDOW_SHOWN );
    SDL_Renderer *renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC);
 
    int isInited = 0;
    ThreadContext tc;
    
    int count = 120;
    for (;;) {
        
        SDL_Event e;
        while (SDL_PollEvent(&e)) {
            switch (e.type) {
                case SDL_WINDOWEVENT:
                    if (e.window.event == SDL_WINDOWEVENT_CLOSE) {
                        isRunning = false;
                        return 0;
                    }
                    break;
                case SDL_WINDOWEVENT_CLOSE:
                    isRunning = false;
                    return 0;
                    break;
                default:
                    break;
            }
        }
        if (!isInited && count <= 0) {
            if (initGLWindow(&secondThread, &tc)) {
                return 1;
            }
            isInited = 1;
        }
        else {
            count--;
        }
        
      
        SDL_SetRenderDrawColor(renderer, 255, 0, 0, 255);
        SDL_RenderClear(renderer);
        SDL_RenderPresent(renderer);

    }
    
    return 0;
}
